/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm.ejb;

import javax.ejb.CreateException;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.namespace.QName;

import org.apache.wsif.WSIFException;
import org.apache.wsif.WSIFMessage;
import org.apache.wsif.WSIFPort;
import org.apache.wsif.WSIFRequest;
import org.apache.wsif.WSIFService;
import org.apache.wsif.WSIFServiceFactory;

import com.ibm.bpe.cm.util.CollectionPointInfo;
import com.ibm.bpe.cm.util.IntegrationException;
import com.ibm.mm.sdk.common.DKException;
import com.ibm.mm.sdk.common.DKPidICM;

/**
 * CollectionPointJavaServiceMDB
 * Generated code. Only edit user code sections.
 * @generated
 */
public class CollectionPointJavaServiceMDB
  implements javax.ejb.MessageDrivenBean, javax.jms.MessageListener
{
  /**
   * @generated
   */
  private static final String fieldWSADIEVersion = "5.0";
  /**
   * @generated
   */
  private javax.ejb.MessageDrivenContext fieldMessageDrivenContext;
  /**
   * @generated
   */
  private WSIFPort _inboundPort = null;

  /**
   * setMessageDrivenContext
   * @generated
   */
  public void setMessageDrivenContext(javax.ejb.MessageDrivenContext newMessageDrivenContext)
  {
    fieldMessageDrivenContext = newMessageDrivenContext;
  }
  /**
   * onMessage
   * @generated
   */
  public void onMessage(javax.jms.Message msg)
  {
    try
    {
      collectionPoint(msg);
    }
    catch (WSIFException e)
    {
      throw new IntegrationException(e);
    }
    catch (javax.jms.JMSException e)
    {
      throw new IntegrationException(e);
    }
  }
  /**
   * ejbCreate
   * @generated
   */
  public void ejbCreate()
  {
    try
    {
      InitialContext initialContext = new InitialContext();
      _contentManagerIntegrationEjbHome =
        (ContentManagerIntegrationLocalHome) initialContext.lookup(
          "java:comp/env/ejb/ContentManagerIntegration");
    }
    catch (NamingException exc)
    {
      throw new IntegrationException(exc);
    }
  }

  /**
   * ejbRemove
   * @generated
   */
  public void ejbRemove()
  {
    if (_inboundPort != null)
    {
      try
      {
        _inboundPort.close();
      }
      catch (WSIFException e)
      {
        throw new javax.ejb.EJBException(e);
      }
    }
  }

  /**
   * Process a new collection point request
   * @param msg The message from the business process
   * @throws WSIFException
   * @throws javax.jms.JMSException
   */
  public void collectionPoint(javax.jms.Message msg) throws WSIFException, javax.jms.JMSException
  {
    System.out.println("collectionPoint start");
    
    org.apache.wsif.providers.jms.WSIFPort_Jms port =
      (org.apache.wsif.providers.jms.WSIFPort_Jms) getInboundPort();
    org.apache.wsif.providers.jms.JMSFormatter formatter =
      (org.apache.wsif.providers.jms.JMSFormatter) port.getFormatter();
    WSIFRequest request = formatter.unformatRequest(msg);
    WSIFMessage inRequestMsg = request.getIncomingMessage();
    // get the (well-known) parts from the message
    String folderItemPid = (String) inRequestMsg.getObjectPart("folderItemPid");
    String[] itemTypeNames = (String[]) inRequestMsg.getObjectPart("itemTypeNames");
    int[] itemTypeQuantities = (int[]) inRequestMsg.getObjectPart("itemTypeQuantities");
    Long timeoutDurationObject = (Long) inRequestMsg.getObjectPart("timeoutDurationMillis");
    long timeoutDuration = timeoutDurationObject.longValue();

    // the correlation ID of the JMS message will be used later to correlate a response
    String correlationId = msg.getJMSMessageID();

    // the collection point implementation needs the itemId of the folder
    // rather than the itemPID (use CM ID handling functions to get the folderItemId)    
    String folderItemId;
    try
    {
      DKPidICM pid = new DKPidICM(folderItemPid);
      folderItemId = pid.getItemId();
    }
    catch (DKException exc)
    {
      throw new IntegrationException(exc);
    }

    //
    // The timeout value is either 
    //    0, which indicates that the collection point should wait forever
    // or 
    //   >0, then we add the value  to the current time
    //
    long timeout = 0L;
    if (timeoutDuration > 0)
    {
      timeout = System.currentTimeMillis() + timeoutDuration;
    }

    CollectionPointInfo info =
      new CollectionPointInfo(
        correlationId,
        folderItemId,
        itemTypeNames,
        itemTypeQuantities,
        timeout);

    System.out.println("register collection point");
    try
    {
      ContentManagerIntegrationLocal contentManagerIntegrationEjb =
        _contentManagerIntegrationEjbHome.create();
      contentManagerIntegrationEjb.addCollectionPointRequest(info);
    }
    catch (CreateException createExc)
    {
      throw new IntegrationException(createExc);
    }
  }

  /**
   * getInboundPort
   * @generated
   */
  public WSIFPort getInboundPort() throws WSIFException
  {
    if (_inboundPort == null)
    {
      WSIFService service =
        WSIFServiceFactory.newInstance().getService(
          "com/ibm/bpe/cm/CollectionPointJMSService.wsdl",
          this.getClass().getClassLoader(),
          "http://cm.bpe.ibm.com/CollectionPointJMSService/",
          "CollectionPointService",
          "http://cm.bpe.ibm.com/CollectionPoint/",
          "CollectionPoint");

      if (service == null)
        return null;

      service.mapType(
        new QName("http://cm.bpe.ibm.com/", "ArrayOfString"),
        java.lang.String[].class);
      service.mapType(new QName("http://cm.bpe.ibm.com/", "ArrayOfInt"), int[].class);

      _inboundPort = service.getPort("CollectionPointJMSPort");
    }
    return _inboundPort;
  }

  ContentManagerIntegrationLocalHome _contentManagerIntegrationEjbHome;

}
