/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm.ejb;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.ibm.bpe.api.QueryResultSet;
import com.ibm.bpe.cm.util.CollectionPointInfo;

/**
 * Local interface for Enterprise Bean: ContentManagerIntegration
 */
public interface ContentManagerIntegrationLocal
	extends javax.ejb.EJBLocalObject
{
	
	public void checkCollectionPoint();
	public void addCollectionPointRequest(CollectionPointInfo info);
	public List listCollectionPointRequests();
	public void deleteCollectionPointRequest( String correlationId );

	public boolean evaluateCondition(String xPath);	

  public Object getFolderContentAttribute(String folderPidString, String attributeSpecification);
  public Object getContentAttribute(String pidString, String attributeSpecification);
  
	public ArrayList getFolderContentAttributes(String folderPidString, String[] attributeSpecifications);

	public ArrayList getContentAttributes(String itemPidString, String[] attributeSpecifications);
	
	public void checkDocumentChangeAction();

	public QueryResultSet combinedQuery(
		String selectClauseWorkflow,
		String flowItemTypeNameContent,
		String flowItemTypeAttributesContent,
		String additionalAttributesContent,
		String whereClauseWorkflow,
		String xPathContent,
		String orderByClauseWorkflow,		
		java.util.TimeZone timezoneWorkflow);
		
	public Map getItemTypeAttributeNames();	
}
