/*
@copyright(disclaimer)

Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 2005. All Rights Reserved.

US Government Users Restricted Rights
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.

DISCLAIMER OF WARRANTIES :

Permission is granted to copy and modify this  Sample code, and to
distribute modified versions provided that both the copyright
notice,- and this permission notice and warranty disclaimer  appear in all copies and modified
versions.

THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.
IBM  AND ITS SUPPLIERS AND LICENSORS  DISCLAIM
ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY
OF NON-INFRINGEMENT AND THE IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
PARTICULAR PURPOSE. IN NO EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY
DAMAGES ARISING OUT OF THE USE OF  OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF
THE SAMPLE CODE, OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL
IBM OR ITS LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA,
OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS
HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

@endCopyright
*/

package com.ibm.bpe.cm.util;

import com.ibm.bpe.api.QueryResultSet;

public class QueryResultSetAdapter
{
  private QueryResultSet _queryResultSet;
  private int _columnsToSkip;

  public QueryResultSetAdapter(QueryResultSet queryResultSet, int columnsToSkip)
  {
    _queryResultSet = queryResultSet;
    _columnsToSkip = columnsToSkip;
  }
  public boolean next()
  {
    return _queryResultSet.next();
  }
  public String getString(int columnIndex)
  {
    return _queryResultSet.getString(columnIndex + _columnsToSkip);
  }
  public String getAbsoluteString(int columnIndex)
  {
    return _queryResultSet.getString(columnIndex);
  }
  public boolean first()
  {
    return _queryResultSet.first();
  }
  public int numberColumns()
  {
    return _queryResultSet.numberColumns() - _columnsToSkip;
  }
  public String getColumnDisplayName(int columnIndex)
  {
    return _queryResultSet.getColumnDisplayName(columnIndex + _columnsToSkip);
  }
  public short getColumnType(int columnIndex)
  {
    return _queryResultSet.getColumnType(columnIndex + _columnsToSkip);
  }
  public Object getOID(int columnIndex)
  {
    return _queryResultSet.getOID(columnIndex + _columnsToSkip);
  }
  public Object getObject(int columnIndex)
  {
    return _queryResultSet.getObject(columnIndex + _columnsToSkip);
  }
}