<%--  
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                            
                                                                       
Permission is granted to copy and modify this  Sample code, and to      
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions.

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                    
                                                                 
@endCopyright
--%>

<%-- This is the general error page that is shown if an exception occurs in a servlet or JSP.  It needs to be specified in the
     'login-config' section of the web deployment descriptor accessible through the 'pages' tab of the Deployment Descriptor Editor.
	 Since it includes the general header.jsp the breadcrumb navigation may be used to restore from the error.
--%>

<%-- customize the title text --%>
<% request.setAttribute("title", "Error"); %>

<%@include file="header.jsp"%>

<%-- overwrite the page include directive of header.jsp --%>
<%@ page 
		 isErrorPage="true"
%>

<%  // if the Content Manager connection is unavailable, logout and show the entry screen
    CMBConnection connection = (CMBConnection) session.getAttribute("connection");
	if (connection == null) {
%>
		<jsp:forward page="logout.jsp"/>
<%  }
%>

<H1>An error has occurred.</H1>

<%-- Display exception if it has not been caught by the servlet or JSP. --%>

<%
  try {
	// try to checkIn any potentially checked out items
	if (folderPid != null) {
    	CMBDataManagement dataBean = Helpers.setupDataBean(request, folderPid, false);
		try { dataBean.checkIn(); } catch (CMBException e) {}
		if (itemId != null) {
	    	dataBean = Helpers.setupDataBean(request, itemId, false);
			try { dataBean.checkIn(); } catch (CMBException e) {}
		}
	}

	// Display error message if one is available. If forwarded from a Servlet this is in general not the case.
	if (exception != null) {
		String	errorMessage = exception.getMessage();
		if (errorMessage != null) {
%>
			<P class="mono"><%=errorMessage%></P>
<%
		}
		exception.printStackTrace();
	}
%>


<P class="indent">
	Check the server log for details.
</P>

<%
   } 
   catch (Exception e) {
   		e.printStackTrace();
   }
%>

</BODY>
</HTML>
