<%--
@copyright(disclaimer)
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                  
Use, duplication or disclosure restricted by GSA ADP Schedule
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                      
                                                                       
Permission is granted to copy and modify this Sample code, and to 
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                      
                                                                 
@endCopyright
--%>

<% request.setAttribute("title", "Help"); %>

<%@include file="header.jsp"%>

<div class="helpsection">

<h3>Help Contents</h3>

<ul>

    <li><a href="#logon">Logging on</a></li>
    <li><a href="#createprocinst">Creating process instances</a></li>
    <li><a href="#dispselworkitem">Displaying and selecting work items</a></li>
    <li><a href="#workwithworkitem">Working with process data, folders, and documents</a></li>
    <li><a href="#remitem">Removing items from a folder</a></li>
    <li><a href="#additem">Adding items to a folder</a></li>
    <li><a href="#changeattrparts">Changing item attributes and parts</a></li>
    <li><a href="#workwithparts">Working with document parts</a></li>
    <li><a href="#navigate">A note on Navigating and Logging out</a></li>
</ul>

<h3><a name="logon">Logging on</a></h3>

The Quick Start Client is launched by pointing the browser to <code>http://localhost:11605/QuickStartClient</code>
Its initial page shows an abstract representation of the claims handling process. The boxes with an icon representing a person in the top
right corner correspond to activities performed by staff members of the insurance company.<br>
The sample scenario supports four work areas, one external to the process (Mailroom) and three participating in the process
(Validate and Adjust, Review Small Claim, and Review Large Claim).<br>
A user's work area can be entered by clicking on the corresponding box and logging on with the userid and password of a user that belongs to the appropriate group
(Agent1 for AgentsGroup, Adjuster1 for AdjustersGroup, Underwriter1 for UnderwriterGroup, and UnderwriterAssistant1 for UnderwriterAssistantsGroup).

<h3><a name="createprocinst">Creating Process Instances</a></h3>

<p>
<i>Mailroom</i> users are responsible for converting incoming documents into electronic format and adding them to the content management
system. The sample scenario offers three different ways to accomplish this. The first two (Create documents, Import predefined documents)
illustrate the use of <i>Content Event Handling</I>. Entering attribute values and clicking 'Store' for a ClaimForm, AdjusterReport
or PoliceReport creates a new item in DB2 Content Manager. Content Event Handling then triggers the creation of an instance
of the process specified by the attribute <code>WF_OnCreate</code>. 'Create documents' can be used to create a new document from scratch while 'Import
predefined documents' simplifies item creation by providing predefined properly formatted and useful attribute values.<br>
Either of these options leads the 'Edit Attributes' page that displays the attributes including any predefined or default values. On this page the actual documents (files)
can be imported by clicking 'Add Part', specifying the Part Type and Mime Type, locating the appropriate file on the client's file system
and clicking 'Import' (see <a href="#changeattrparts">Changing attributes and parts</a> for details).<br>
Instead of creating new items and using Content Event Handling to create items, 'Create process instances for existing items' can be used
to create process instances explicitly. Clicking 'Submit' performs a Content Manager query based on the XPath query string in the input
field and explicitly creates a process instance for each element of the result list.
The default query is <code>/XYZ_ClaimFolder</code> that returns all currently available claim folders. Process creation can be restricted to
a subset of the available claim forms by adding an attribute-related condition to the query string as for example <code>/XYZ_ClaimFolder[@ClaimLName = "Twain"]</code>.
</p>

<h3><a name="dispselworkitem">Displaying and selecting work items</a></h3>

<p>
When logged on as a user for one of the process roles (Adjuster1, Underwriter1, or UnderwriterAssistant1) the user's initial page shows the work
list for the corresponding staff activity (Validate and Adjust, Review Large Claim, or Review Small Claim). The work list results from a <i>Combined Query</i>.
It shows content attributes (Date of Incident, Claim Number, ...) and process properties (Activated, Work Item State) returned by the query in a tabular format.
The worklists of the 'Review' activities differ from the worklist for 'Validate and Adjust' in that they additionally contain a column with
the date of the Adjuster Report. The other columns are the same for all three staff activities.
The rightmost column of a work list shows the actions that can be performed on a work item. An action can be either 'Open' if the work
item is already checked out by this user or 'Fetch' if the user has not yet checked it out. Checking out a work item prevents it from
being checked out by a different user of the same group. Clicking 'Fetch' checks out a work item and displays the Work Page. Clicking 'Open'
displays the Work Page of an already checked-out item.
</p>

<h3><a name="workwithworkitem">Working with process data, folders, and documents</a></h3>

<p>
A work item contains the information that is required to perform a step in the process. The Quick Start Client displays this information
in two or three sections depending on the type of item that is routed through the process:
</p>

<ul>
    <li><i>Process activity</i> ... represents process data such as elements of this staff activity's input message</li>
    <li><i>Folder</i> or <i>Document</i> ... represents attributes of the folder or document that is routed through the process</li>
    <li><i>Items in folder</i>  ... is an optional section that lists the documents contained in the folder if the item routed through the process
        is a folder</li>
</ul>

<p>
The contents of the <i>Process activity</i> section depend on the staff activity to which this work item belongs. The 'Validate and Adjust'
activity shows a status message concerning contract retrieval ("Contract retrieved" or "Contract not found"), a message that says how
many times a timeout condition has occurred ("Reminder count") and three input elements that define conditions for the <i>Collection Point
Service</I> ("Required documents").<br>
The 'Review Large Claim' activity displays the result of the Fraud History Service, an input field ("Justify decision") and two radio
buttons for approving or rejecting the claim. The 'Review Small Claim' activity differs from 'Review Large Claim' in that it does
not include the fraud history report as the Fraud History Service is not involved when dealing with small claims.<br>
The 'Actions' column of the <i>Process activity</i> section provides two actions. 'Complete' checks the work item and moves it to the
next step in the process. 'Cancel' can be used to undo a 'Fetch' action by un checking the work item and leaving it at this staff
activity so it is available to be checked out again by a person with the appropriate role.
'Cancel' or 'Complete' leads back to the list of work items.<br>
Note that the data in the 'Process activity' section is not necessarily stored in DB2 Content Manager. Some of the data may only exist while
the process instance is active.
</p>

<p>
The Content sections ('Folder', 'Document', or 'Items in folder') display the object's name (value of the attribute which represents the item)
in the first row followed by the rows that list attribute/value pairs followed by rows that list part type/mime type pairs for the parts
associated with this item. Child attributes are indented to separate them from atomic attributes. Names of child attributes are displayed
in bold face.<br>
The final column provides a subset of the following actions depending on the type of object being displayed and the ACL that applies to this user/group and object:
</p>

<ul>
    <li>Edit ... change the document or folder's attributes and add or delete parts. See <a href="#changeattrparts">Changing item attributes and parts</a> for
    details.</li>
    <li>Add ... add an item to the folder if the item being routed through the process if of semantic type 'folder'. See <a href="#additem">Adding
        items to a folder</a> for details.</li>
    <li>View ... open a part with an associated viewer. See <a href="#workwithparts">Working with parts</a> for details.</li>
    <li>Delete ... delete this document from the enclosing folder. See <a href="#remitem">Deleting items from a folder</a> for details. Delete is not
        available for the item routed through the folder.</li>
</ul>

<p>
A typical course of actions for a process role looks as follows:
</p>
<ul>
	<li>investigate the attribute/value pairs of the folder and its contents</li>
	<li>click 'Edit' for some items to update their attribute values and/or parts</li>
	<li>click 'View' on one or more parts to display them in a viewer window. Multiple viewer windows may be open at the same time.</li>
	<li>add annotations to parts opened in applet viewer windows by highlighting important areas or adding notes</li>
	<li>click 'Add' to add a new item to the folder or 'Delete' to delete one or more of the items from the folder</li>
	<li>verify and enter values in the 'Process activity' section (values entered in this section are lost when performing Edit, Add, View, or Delete operations)</li>
	<li>click 'Complete' to proceed with the next step of the process</li>
</ul>

<p>
Prior to returning to the Work List page, the 'Complete' action opens a confirmation dialogue which prevents the user from completing a work
item accidentally. Clicking 'Cancel' prevents the action from being completed while 'OK' checks in the work item and moves it to the next
step in the process. This removes the work item from the worklist of this user (as only work items are shown where for which the user has the
potential owner role).
</p>


<h3><a name="remitem">Removing items from a folder</a></h3>

<p>
A document can be deleted by clicking 'Delete' on the corresponding row of the Work Page. This removes the item and its
parts from the library server and resource manager and deletes the containment link which made this item a member of the folder.
</p>

<p>
A confirmation dialogue is shown prior to deleting the document.
</p>

<h3><a name="additem">Adding items to a folder</a></h3>

<p>
To add an item to a folder click 'Add' in the 'Folder' section of the Work Page. This opens the 'Add item to folder' dialogue that asks
for an item type. In a specific process scenario this function will typically be replaced by a more specific action that adds an item
of a certain type to the folder which makes the generic 'Add item to folder' dialogue unnecessary.
Clicking 'Create' when an item type has been selected opens the 'Edit item' dialogue described in the next paragraph.
</p>

<h3><a name="changeattrparts">Changing item attributes and parts</a></h3>

<p>
The 'Edit item' dialogue consists of two sections. The first column in the section 'Edit attributes' displays the value of the
attribute that represents the item (item name). Columns two and three display the item attributes and their values. The values are represented
by input fields that may be pre-populated if the item already exists or if the item type defines a default value for this attribute.
The size of the input field depends on the attribute definition (input field or textarea).
The final column of this section lists the 'Save' action which updates the item with the attribute values in the input fields.
A red asterisk in front of the attribute name indicates a mandatory value.
If the 'Edit item' dialogue was opened as the result of adding an item to a folder, the value of the auto link attribute
is initialized with the value of the corresponding folder attribute and can not be changed.<br>
Child items are highlighted in bold face with their attribute/value pairs indented. The only available action for child items
is 'Add Child' which displays a new initially empty child item. The quick start client does not provide a delete operation for
child items.
<br>
The 'Edit parts' section lists the part number, part type and mime type of parts assigned to the item. The action 'Add Part'
allows to select add a new part from the list of supported part types and add it to the item. 'View' opens the viewer in a new browser window.
'Delete' shows a confirmation dialogue prior to deleting a part. If answered positively it removes the part from the Resource Manager and
updates the parts list of the item.
</p>

<p>
Clicking 'Add Part' opens the 'Add Part' page which lists the supported part types to select from and asks for the mime type and location of the
file that should be imported into the parts list of this item. The mime type selection offers 'Defined by extension' as a default
which may be appropriate if the file name extension indicates the corresponding mime type as in the case of .txt, .html,
.pdf and many other extensions. Some extensions as for example .jpeg are not supported by automatic mime type detection. In this
case the mime type needs to be selected explicitly. Clicking 'Import' adds the part to the parts list of the item and re opens the 'Edit item'
page.
</p>

<p>
Clicking 'Save' on the 'Edit item' page stores the updated attribute values to the library server and reloads the page from which the 'Edit item'
dialogue was invoked. A pop-up windows that says "Check attribute values. At least one is invalid or a mandatory one is missing" indicates
a problem with one or more attribute values. Typical causes are a mandatory value that is missing, or a violation of attribute properties such
as field length, character type, uniqueness and the like. Check the item type definition with the Content Manager Administration Client if necessary.
</p>

<h3><a name="workwithparts">Working with parts</a></h3>

<p>
Clicking 'View' in the action column of a part row opens a new browser window which displays the part content. If the mime type of
this part is supported by the
Content Manager viewer applet, this window contains an instance of the viewer applet. The viewer applet displays the 
document content and allows the user to create and/or modify annotations that are associated with this part if annotations are supported by the item type.
Selecting File-&gt;Save or clicking the 'Save' icon on the Control Menu assigns the annotation to the base part and adds it to the parts
list of the item. A confirmation window pops up if the annotation has been stored. Selecting File-&gt;Reload displays the
content in a new viewer panel of the applet. Check out the Content Manager Information Center for details on capabilities provided
by the applet viewer. Most of the applet viewer's capabilities are available in the Quick Start Client.
</p>

<p>
If the mime type is not supported by the viewer applet (for example text/html or application/pdf) the viewer window renders the
content part based on its capabilites or a corresponding plugin, if available. In this case the content is displayed in read-only mode.
</p>

<p>
Since parts are displayed in separate browser windows, different parts associated with a document can be viewed at the same
time. If the content is not of interest any longer, the corresponding browser window can be closed by clicking 'Close' in the menu bar of the
viewer window or the standard means of the browser or operating system.
It is important to consider if a 'Save' operation may be needed on an applet window before closing the windows to ensure that the
annotations and potential updates are preserved.
</p>

<h3><a name="navigate">A note on Navigation and Logging out</a></h3>

<p>
The Quick Start Client shows a header on each page that consists of the sample logos and a menu that displays the following three elements:
</p>

<ul>
   <li>Close link (viewer page or help page ... closes the page) or Help link (any other page ... opens this document)</li>
   <li>Breadcrumb navigation .... a sequence of links separated with the symbol '&gt;'. These links allow backward navigation to
       pages that logically precede the current page in the page history. It can for example be used to go back to the Work Item or Work List
       Page from any lower level dialogue such as 'Edit item'.
       Note that if the action on this lower level page has not been completed by clicking the Submit button on this page (which may be
       titled 'Save', 'Import', ....) any data in fields of the form will be lost. Breadcrumb navigation can also be used to recover from
       error situations since the error page lists the pages to which navigation is possible in the breadcrumb navigation section of the menu.
       In some cases no links are present and the only possible action is to redirect the pointer to the Quick Start Client's initial page.</li>
   <li>The name of the currently logged-on user preceded by "UserID".</li>
   <li>Logout ... a link that closes the current activity and opens the Quick Start Client's initial page. To ensure any potential incomplete work
        is preserved it is recommended to consider clicking the Submit ('Save', 'Complete', 'Import', ...) button prior to logging out.</li>
</ul>

</div>

</BODY>
</HTML>