<%--	
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1995,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :
                                                                       
Permission is granted to copy and modify this Sample code, and to
distribute modified versions provided that both the copyright
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
                                                                 
@endCopyright
--%>

<%-- This JSP implements a work item page consisting of the following two or three sections:
	 - process section / folder section / folder contents section  - if the process instance is linked to a folder
	 - process section / document section - if the process instance is linked to a document
	 The process section contains a form that is based on a subset of the activity input message while the
	 folder, document or folder contents section list CM attributes and their values.
--%>

<% request.setAttribute("title", "Work"); %>

<%@include file="header.jsp"%>
<%@page errorPage="/error.jsp"%>
<%@ taglib uri="cmb" prefix="cmb" %>

<%
    Helpers.validateConnection(request);
	BusinessProcess bps = (BusinessProcess)session.getAttribute("ProcessService");
	ActivityInstanceData activity = bps.getActivityInstance(aiidString);
	int activityState = activity.getExecutionState();
    String activityName = activity.getName();
	
	// if the work item has been fetched (parameter CLAIM=true) claim the activity instance
    if (request.getParameter("CLAIM") != null && activityState == ActivityInstanceData.STATE_READY) {
    	bps.claim(aiidString);
    	System.out.println("-> Work item claimed.");
    }
  
  	// If the folderPid is not in the request, create one from the 'itemPid' custom property of the current
  	// process instance
  	if (folderPid.length() == 0) {
		PIID piid = activity.getProcessInstanceID();
		ProcessInstanceData pidata = bps.getProcessInstance(piid);
		String pidString = (String) pidata.getCustomProperty("itemPid");
		DKPidICM pid = new DKPidICM(pidString);
		folderPid = pid.pidString();
		encodedFolderPid = java.net.URLEncoder.encode(folderPid, "UTF-8");
	}

	// Initialize the data management and item beans with the item identified by the folderPid
    CMBDataManagement dataBean = Helpers.setupDataBean(request, folderPid, true);
    CMBItem flowItem = dataBean.getDataObject();
    
    // Look up the entity (item type) definition of the item routed through the process
    // This is needed to access the (translated) display name
	String attrDisplayName;
	CMBConnection connection = (CMBConnection) session.getAttribute("connection");
	CMBSchemaManagement schemaBean = connection.getSchemaManagement();
    CMBEntity entity = schemaBean.getEntity(flowItem.getEntityName());	
	
	boolean flowItemIsFolder = (flowItem.getItemType() == CMBBaseConstant.CMB_TYPE_FOLDER);
	String objectName = (flowItemIsFolder) ? "Folder" : "Item";
%>

<%-- Confirmation dialogues --%>

<SCRIPT type="text/javascript">
<!--
function confirmDelete(deleteId) {
	var target = 'DeleteItemServlet?folderPid=<%=encodedFolderPid%>&WF_AIID=<%=aiidString%>';
	if (confirm('Confirm deletion this item?')) target += '&deleteID=' + deleteId;
	window.location.href = target;
}

function confirmComplete(deleteId) {
	var target = 'showWorkItem.jsp?folderPid=<%=encodedFolderPid%>&WF_AIID=<%=aiidString%>';
	if (confirm('Confirm completion of this step'))
		document.complete.submit();
	else
		window.location.href = target;
}
//-->
</SCRIPT>

<%-- The Cancel action calls the CompleteWorkServlet with the parameter 'CANCEL=true' to 'un-claim' the work item --%>
<FORM action="CompleteWorkServlet?WF_AIID=<%=aiidString%>&CANCEL=true" method="POST" name="cancel">
</FORM>

<%-- The Complete action calls the CompleteWorkServlet to complete the work item --%>
<FORM action="CompleteWorkServlet?WF_AIID=<%=aiidString%>" method="POST" name="complete">
	<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">
		
		<!-- Process parameters -->
		<TR>
			<TD colspan="5" class="mainseparator">Process activity</TD>
		</TR>

		<TR>
			<TH colspan="4"><%=activityName%></TH>
			<TH>Actions</TH>
		</TR>
		
		<%-- **************************** PROCESS SECTION ******************************** --%>
		<TR>
<%          // Access the input message of this activity; the output message is instantiated upon activity completion
			// by the CompleteWorkServlet.
			WSIFDefaultMessage inMsg = null;
		    ClientObjectWrapper cow = bps.getInputMessage(aiidString);
		    if (cow != null) inMsg = (WSIFDefaultMessage) cow.getObject();
%>
			<%-- Include the activity-specific part of this section as defined by ProcessData.staffActions() --%>
		    <%=ProcessData.staffActions(activityName, inMsg)%>

			<TD>
				<A href="javascript:confirmComplete()">Complete</A><BR>
				<A href="javascript:document.cancel.submit()">Cancel</A>
			</TD>
		</TR>
		<TR><TD>&nbsp;</TD></TR>
	
		<%-- **************************** DOCUMENT / FOLDER SECTION ******************************** --%>
		<TR>
			<TD colspan="5" class="separator"><%=objectName%></TD>
		</TR>
	
		<TR>
			<TH width="20%"><%=objectName%> Name</TH>
			<TH width="20%">Type / Parts</TH>
			<TH width="43%" colspan="2">
				<TABLE width="100%">
					<TR><TH width="50%">Attribute name</TH><TH width="50%">Attribute value</TH></TR>
				</TABLE>
			</TH>
			<TH width="%17">Actions</TH>
		</TR>
		
		<TR valign="top">
			<TD><%=flowItem.getName()%> </TD>
	        <TD><%=Helpers.prepareName(entity.getDisplayName())%></TD>
			<TD colspan="2">
			  <TABLE width="100%">
				<cmb:itemattributes item="<%=flowItem%>">
<%					// do not show the attributes WF_OnCreate or WF_OnDelete since they are considered internal
					// and only modified by the administrator. Alternatively, the could be hidden by using a view.
					if (attrname.length() != 11 || !attrname.substring(0, 5).equals("WF_On")) {
						attrDisplayName = Helpers.prepareName(entity.getAttribute(attrname).getDisplayName());
%>
						<TR>
							<TD width="50%"><%=attrDisplayName%></TD>
							<TD width="50%"><%=attrvalue%></TD>
						</TR>
<%
					}
%>
				</cmb:itemattributes>
			  </TABLE>
			</TD>
			
			<%-- flow item-level Actions --%>
			<TD style="padding-bottom=5pt">
<%
				// display 'Edit...' and 'Add xxx' buttons only if logged-on user has the appropriate privileges
				dataBean.setDataObject(flowItem);
				boolean authorized = dataBean.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_EDIT_ATTRIBUTE) == CMBPrivilege.CMB_PRIV_YES;
				if (authorized) {
%>
					<A href="updateAttributes.jsp?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedFolderPid%>">Edit...</A><BR>
<%				}
				if (flowItemIsFolder) {
					String[] addToFolderActionItemTypes = ProcessData.getAddToFolderActionItemTypes(roleId);
					int numOfAddOperations = addToFolderActionItemTypes.length;
					if (numOfAddOperations > 0) {
						authorized = dataBean.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_ADD_TO_FOLDER) == CMBPrivilege.CMB_PRIV_YES;
						if (authorized) {
							String[] addToFolderActionNames = ProcessData.getAddToFolderActionNames(roleId);
							for (int i = 0; i < numOfAddOperations; i++) {
%>
								<A href="updateAttributes.jsp?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=&entityName=<%=addToFolderActionItemTypes[i]%>">Add <%=addToFolderActionNames[i]%></A><br>
<%							} // for
						} // if authorized to add to a folder
					} // if add operations are avaiable for this activity
				} // if flow item is a folder
%>
			</TD>
		</TR>
	
			
		<%-- **************************** FOLDER CONTENT SECTION (optional) ******************************** --%>
<%		int contentIndex = 0;   %>			
			
		<cmb:itemcontents data="<%=dataBean%>" item="<%=flowItem%>">
<%		
		String encodedContentId = java.net.URLEncoder.encode(content.getId(), "UTF-8");
%>
		<TR>
			<TD></TD>
			<TD>Part <%=contentIndex%></TD>
			<TD colspan="2">
			<TABLE width="100%">
				<TR>
				<TD width="50%"><%=content.getPartType()%></TD>
				<TD width="50"><%=content.getMimeType()%></TD>
				</TR>
			</TABLE>
			</TD>
			<TD>
		    	<%-- Open a new window to show the content. This allows viewing/editing multiple parts of an item concurrently. --%>
				<A href="viewContent.jsp?menu=no&WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&contentId=<%=encodedContentId%>&contentIndex=<%=contentIndex%>&contentMimeType=<%=content.getMimeType()%>" target="_blank">View</A>
			</TD>
		</TR>
<%
		contentIndex++;
%>
		</cmb:itemcontents>
	
	
		<%-- **************************** FOLDER MEMBERS SECTION (optional) ******************************** --%>
<%			
	if (flowItemIsFolder) {  // if the flowItem is a folder show the items it contains (attributes/parts)
%>
		<TR></TR>
		
		<TR>
			<TD colspan="5" class="separator">Items in folder</TD>
		</TR>
	
		<TR>
			<TH>Item Name</TH>
			<TH>Type / Parts</TH>
			<TH colspan="2">
				<TABLE width="100%">
					<TR><TH width="50%">Attribute name</TH><TH width="50%">Attribute value</TH></TR>
				</TABLE>
			</TH>
			<TH>Actions</TH>
		</TR>
<%		int counter = 0;
		String styleClass;
%>
		<cmb:folderitems folder="<%=flowItem%>">
<%
			styleClass = ( counter % 2 == 0 )? "even" : "odd" ;
			counter++ ;
			entity = schemaBean.getEntity(item.getEntityName());
%>
			<TR valign="top" class="<%=styleClass%>">
			
				<TD><%=item.getName()%></TD>
				<TD><%=Helpers.prepareName(entity.getDisplayName())%></TD>
				
				<TD colspan="2">
					
					<TABLE width="100%">
					<cmb:itemattributes item="<%=item%>">
<%
						// an attribute may a collection of child items. In this case list the display name
						// of the child item followed by its attributes and their values.
						short attributeType = (new Short(attrtype)).shortValue();
						if (attributeType == CMBBaseConstant.CMB_DATATYPE_ITEM ||
						    attributeType == CMBBaseConstant.CMB_DATATYPE_ITEM_COLLECTION) {
						    CMBItem[] items = item.getAttrItems(attrname);
						    String[] childAttrNames, childAttrValues;
						    for (int i = 0; i < items.length; i++) {
							    CMBItem childItem = items[i];
							    CMBEntity childEntity = schemaBean.getEntity(childItem.getEntityName());
%>
								<%-- display the name of the child attribute --%>
								<TR class="<%=styleClass%>">
									<TD width="50%"><B><%=Helpers.prepareName(childEntity.getDisplayName())%></B></TD>
									<TD width="50%"></TD>
								</TR>	
<%
							    childAttrNames = childItem.getAttrNames();
							    childAttrValues = childItem.getAttrValues();
							    for (int j = 0; j < childAttrNames.length; j++) {
								   	attrDisplayName = Helpers.prepareName(childEntity.getAttribute(childAttrNames[j]).getDisplayName());						   
%>
									<%-- display the attribute/value pairs of the child attribute --%>
									<TR class="<%=styleClass%>">
										<TD width="50%">&nbsp;&nbsp;<%=attrDisplayName%></TD>
										<TD width="50%"><%=childAttrValues[j]%></TD>
									</TR>
<%
						    	} // end loop over attributes of the child
							} // end loop over children
						} // end if attribute is collection
						else {
							attrDisplayName = Helpers.prepareName(entity.getAttribute(attrname).getDisplayName());
%>
							<%-- display single (non child) attribute --%>
							<TR class="<%=styleClass%>">
								<TD width="50%"><%=attrDisplayName%></TD>
								<TD width="50%"><%=attrvalue%></TD>
							</TR>
<%						}
%>
					</cmb:itemattributes>
					</TABLE>
				</TD>
	
				<%-- Folder-content-level Actions --%>
				<TD>
<%					// display 'Edit...' and 'Delete' buttons only if logged-on user has the appropriate privileges
					dataBean.setDataObject(item);
					encodedItemId = java.net.URLEncoder.encode(item.getPidString(), "UTF-8");
					authorized = dataBean.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_EDIT_ATTRIBUTE) == CMBPrivilege.CMB_PRIV_YES;
					if (authorized) {
%>
						<A href="updateAttributes.jsp?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>">Edit...</A> <BR>
<%					}
					authorized = dataBean.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_DELETE_ITEM) == CMBPrivilege.CMB_PRIV_YES;
					if (authorized) {
%>
						<A href="javascript:confirmDelete('<%=encodedItemId%>')">Delete</A><BR>
<%					}
%>
				</TD>
			</TR>
			
		<%-- **************************** CONTENT SECTION OF FOLDER MEMBERS (optional) ******************************** --%>
<%			contentIndex = 0;   %>			
			<cmb:itemcontents data="<%=dataBean%>" item="<%=item%>">
<%			String encodedContentId = java.net.URLEncoder.encode(content.getId(), "UTF-8");
%>
			<TR class="<%=styleClass%>">
				<TD></TD>
				<TD>Part <%=contentIndex%></TD>
				<TD colspan="2">
				<TABLE width="100%">
					<TR>
					<TD width="50%"><%=content.getPartType()%></TD>
					<TD width="50"><%=content.getMimeType()%></TD>
					</TR>
				</TABLE>
				</TD>
				<TD>
			    	<%-- Open a new window to show the content. This allows viewing/editing multiple parts of an item concurrently. --%>
					<A href="viewContent.jsp?menu=no&WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&contentId=<%=encodedContentId%>&contentIndex=<%=contentIndex%>&contentMimeType=<%=content.getMimeType()%>" target="_blank">View</A>
				</TD>
			</TR>
<%
			contentIndex++;
%>
			</cmb:itemcontents>

		</cmb:folderitems>
<%
	} // master item is folder
%>
	</TABLE>
</FORM>

</BODY>
</HTML>
