<%--
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :                                  
                                                                       
Permission is granted to copy and modify this  Sample code, and to  
distribute modified versions provided that both the copyright
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.                          
                                                                 
@endCopyright
--%>

<%-- This JSP illustrates the different ways to initiate processes in a CM/BPC environment. I contains three sections
     that simulate different options for starting the sample process.
     1. The first section titled 'Create documents' simulates the manual creation of a document that triggers the
        creation of a process instance based on the 'Content Event Handling' mechanism (see the Quick Start Manual for details)
     2. The second section titled 'Import predefined documents' simulates automatic ingestion of a scanned document.
        By clicking 'Store' a document with predefined values is stored in Content Manager. As with section 1 the
        'Content Event Handling' mechanism triggers the creation of process instances for items of type XYZ_ClaimFolder
     3. The third section titled 'Create process instance for existing items' simulates an application that explicitly
        creates process instances. This replaces the Process Starter Application Client used with the integration sample
        of Content Manager 8.3.
        Clicking 'Submit' launches a Content Manager Query. The StartProcessInstancesServlet contains the code that creates
        a process instance for each element of the result list. A mailroom user can refine the query by entering a
        condition into the input field.
--%>

<%	
	request.setAttribute("title", "Start Process Instances");
	Helpers.validateConnection(request);

	// store the process name in a session attribute;
	String processName = (String)session.getAttribute("process");
	if (processName == null) {
		processName = request.getParameter("processName");
		session.setAttribute("process", processName);
	}
%>

<%@include file="header.jsp"%>
<%@page errorPage="/error.jsp"%>

<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">

	<%-- **************************** SECTION 1: Create documents ******************************** --%>

	<TR>
		<TD colspan="2" class="mainseparator">Create documents</TD>
	</TR>

	<TR>
		<TD>Claim Form</TD>
		<TD><A href="updateAttributes?entityName=XYZ_ClaimForm">Create</A></TD>
	</TR>
	<TR>
		<TD>Adjuster Report</TD>
		<TD><A href="updateAttributes?entityName=XYZ_AdjReport">Create</A></TD>
	</TR>
	<TR>
		<TD>Police Report</TD>
		<TD><A href="updateAttributes?entityName=XYZ_PolReport">Create</A></TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<%-- **************************** SECTION 2: Import predefined documents ******************************** --%>

	<TR>
		<TD colspan="2" class="mainseparator">Import predefined documents</TD>
	</TR>

	<TR>
		<TD colspan="2"><B>Claim Forms</B></TD>
	</TR>

	<TR>
	<TD valign="top">Mary Twain</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_ClaimForm">
		<INPUT type="hidden" name="processName" value="<%=processName%>">	
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Mary">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Twain">	
		<INPUT type="hidden" name="attr.2.XYZ_DriversLic" value="B54673210">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdFName" value="Gregory">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdLName" value="Twain">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		Claim Number: <input type="text" name="attr.2.XYZ_ClaimNumber" value="3-742019">
		<A href="javascript:document.forms[0].submit()">Store</A> 
	</FORM> 
	</TD>
	</TR>

	<TR>
	<TD valign="top">Alexander Churchill</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_ClaimForm">
		<INPUT type="hidden" name="processName" value="<%=processName%>">	
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Alexander">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Churchill">	
		<INPUT type="hidden" name="attr.2.XYZ_DriversLic" value="B23456789">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdFName" value="Jessica">	
		<INPUT type="hidden" name="attr.1.XYZ_InsrdLName" value="Fitzgerald">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10315975308">	
		Claim Number: <input type="text" name="attr.2.XYZ_ClaimNumber" value="3-501699">
		<A href="javascript:document.forms[1].submit()">Store</A> 
	</FORM> 
	</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD colspan="2"><B>Adjuster Reports</B></TD>
	</TR>
	
	<TR>
	<TD valign="top">Adjuster Report for Mary Twain's case</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_AdjReport">
		<INPUT type="hidden" name="processName" value="<%=processName%>">
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.7.XYZ_AdjustDate" value="2005-09-10">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustFName" value="Mike">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustLName" value="Reed">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Mary">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Twain">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	
		<INPUT type="hidden" name="attr.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		Claim Number: <INPUT type="text" name="attr.2.XYZ_ClaimNumber" value="3-742019"><BR>
		Claim Amount: 
		<SELECT name="attr.2.XYZ_ClaimAmount">
			<OPTION value="1000">$1000</OPTION>
			<OPTION value="10000" SELECTED>$10000</OPTION>
			<OPTION value="50000">$50000</OPTION>
		</SELECT>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<A href="javascript:document.forms[2].submit()">Store</A> 
	</FORM> 
	</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
	<TD valign="top">Adjuster Report for Alexander Churchill's case</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_AdjReport">
		<INPUT type="hidden" name="processName" value="<%=processName%>">
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.7.XYZ_AdjustDate" value="2005-09-08">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustFName" value="Bob">	
		<INPUT type="hidden" name="attr.1.XYZ_AdjustLName" value="McLaren">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimFName" value="Robert">	
		<INPUT type="hidden" name="attr.1.XYZ_ClaimLName" value="Fitzgerald">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	
		<INPUT type="hidden" name="attr.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.2.XYZ_PolicyNum" value="10452136412">	
		Claim Number: <INPUT type="text" name="attr.2.XYZ_ClaimNumber" value="3-501699"><BR>
		Claim Amount: 
		<SELECT name="attr.2.XYZ_ClaimAmount">
			<OPTION value="1000" SELECTED>$1000</OPTION>
			<OPTION value="10000">$10000</OPTION>
			<OPTION value="50000">$50000</OPTION>
		</SELECT>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<A href="javascript:document.forms[3].submit()">Store</A> 
	</FORM> 
	</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>

	<TR>
		<TD colspan="2"><B>Police Reports</B></TD>
	</TR>


	<TR>
	<TD valign="top">Mary Twain</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_PolReport">
		<INPUT type="hidden" name="processName" value="<%=processName%>">
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.0.2.XYZ_LicPlate" value="4IBM134">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.1.2.XYZ_DriversLic" value="B54673210">	
		<INPUT type="hidden" name="attr.2.XYZ_ReportNum" value="09092005-22">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-09">	

		Claim Number: <INPUT type="text" name="attr.2.XYZ_ClaimNumber" value="3-742019">
		<A href="javascript:document.forms[4].submit()">Store</a>
	</FORM> 
	</TD>
	</TR>

	<TR>
	<TD valign="top">Alexander Churchill</TD>
	<TD>
	<FORM action="UpdateAttributesServlet" method="POST">
		<INPUT type="hidden" name="entityName" value="XYZ_PolReport">
		<INPUT type="hidden" name="processName" value="<%=processName%>">
		<INPUT type="hidden" name="WF_AIID" value="">	
		<INPUT type="hidden" name="folderPid" value="">	
		<INPUT type="hidden" name="itemId" value="">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.0.2.XYZ_LicPlate" value="1ABC089">	
		<INPUT type="hidden" name="attr.1048.XYZ_VictimInfo.intAttr.1.2.XYZ_DriversLic" value="B98755678">	
		<INPUT type="hidden" name="attr.2.XYZ_ReportNum" value="09062005-21">	
		<INPUT type="hidden" name="attr.7.XYZ_IncDate" value="2005-09-06">	

		Claim Number: <INPUT type="text" name="attr.2.XYZ_ClaimNumber" value="3-501699">
		<A href="javascript:document.forms[5].submit()">Store</a>
	</FORM> 
	</TD>
	</TR>

	<TR><TD>&nbsp;</TD></TR>

	<%-- **************************** SECTION 3: Create process instances for existing items ********************* --%>

	<TR>
		<TD colspan="2" class="mainseparator">Create process instances for existing items</TD>
	</TR>
	<TR><TD>&nbsp;</TD></TR>
	
		<TR>
		<TD colspan="2" >
			<FORM action="StartProcessInstancesServlet?processName=<%=processName%>" method="POST">
				Content Manager Query <INPUT type="text" name="query" size="80" value="/XYZ_ClaimFolder">
				<A href="javascript:document.forms[6].submit()">Submit</A> 
			</FORM>
		</TD>
	</TR>

	<TR>
		<TD colspan="2" >
<%
		String numHits = request.getParameter("numHits");
		if (numHits != null) {
%>
			<%=numHits%> process instances created.
<%
		}
%>
		</TD>
	</TR>

</table>
</body>
</html>
