<%--  
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :
                                                                       
Permission is granted to copy and modify this Sample code, and to
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
                                                                 
@endCopyright
--%>

<%-- This JSP is used to create or modify folder or document attributes and parts. The attribute which is responsible for
     auto linking (as defined by ProcessData.AUTO_LINK_ATTRIBUTE is rendered as read only to avoid confusion
     that might be caused if a user would change the value.
     This page is launched in one of these three situations:
     1. clicking 'Edit...' for an item on showWorkItems page (attribute modification)
     2. clicking 'Add...' in the folder section of the showWorkItem page and selecting an item type on the addToFolder page (attribute creation)
     3. importing a document on the startProcessInstances page (attribute creation)
--%>

<% request.setAttribute("title", "Attributes"); %>

<%@include file="header.jsp"%>
<%@page errorPage="/error.jsp"%>
<%@ taglib uri="cmb" prefix="cmb" %>

<%
	CMBDataManagement dataMgmt = null;
	CMBItem item = null;
	CMBItem folderItem = null;
    String entityName;
    
    // Initialize the data management bean with the flow folder in case of situation 1 or 2 (in the context of the process)
    if (folderPid.length() > 0) folderItem = Helpers.setupDataBean(request, folderPid, true).getDataObject();

	if (itemId.length() > 0) {
		// if an entityName is not available this means that an existing item is to be updated
	    dataMgmt = Helpers.setupDataBean(request, itemId, true);
		item = dataMgmt.getDataObject();
 	  	entityName = item.getEntityName();
 		
		if (dataMgmt.isCheckedOut()) {
			try { // if the item is checked out try to check it in
				dataMgmt.checkIn();
			}
			catch (Exception e) {}
			if (dataMgmt.isCheckedOut())  {
%>
				<SCRIPT type="text/javascript">
				<!--
					alert('Item is locked.');
				//-->
				</SCRIPT>
<%			}
		}
	}
	else {
		entityName = request.getParameter("entityName");
	}
	// set up the data and item beans and obtain the entity (item type definition) of the item the attributes of which
	// should be displayed. The entity is needed to access the (translated) display names of the attributes.
	Helpers.validateConnection(request);  // ensure the connection is valid
	CMBConnection connection = (CMBConnection) session.getAttribute("connection");
	CMBSchemaManagement schemaBean = connection.getSchemaManagement();
    CMBEntity entity = schemaBean.getEntity(entityName);
    CMBAttribute[] attributes = entity.getAttributes();
	boolean itemIsFolder = entity.getType() == CMBBaseConstant.CMB_TYPE_FOLDER;
	String objectName = (item == null) ? "Item type" : (itemIsFolder) ? "Folder name" : "Item name";	
	String itemName = (item == null) ? entityName : item.getName();
	
	// the 'addChild' parameter points to the final position of the child collection if a new child attribute
	// should be added to the item
	String newChildIndexString = request.getParameter("addChild");
	int newChildIndex = (newChildIndexString == null) ? -1 : (new Integer(newChildIndexString)).intValue();
%>			

<%-- confirmation dialogue to be opened prior to submitting a delete request --%>
<SCRIPT type="text/javascript">
<!--
	function confirmation(itemId, contentId, contentIndex) {
		var target = 'DeletePartServlet?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&contentId=' + contentId;
		if (confirm('Do you really want to delete this part?')) target = target + '&deleteCI=' + contentIndex;
		window.location.href = target;
	}
//-->
</SCRIPT>

<FORM action="UpdateAttributesServlet?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&entityName=<%=entityName%>" method="POST">
<TABLE border="0" cellpadding="0" cellspacing="0" width="100%">
	<TR>
		<TD colspan="4" class="mainseparator">Edit attributes</TD>
	</TR>

	<%-- TABLE HEADER --%>

	<TR>
		<TH><%=objectName%></TH>
		<TH>Attribute name</TH>
		<TH>Attribute value</TH>
		<TH>Action</TH>
	</TR>

	<%-- EDIT ATTRIBUTES SECTION --%>

	<TR valign="top">
		<TD><%=itemName%></TD>
		<TD colspan="2"></TD>
		<TD valign="top">
			<A href="javascript:document.forms[0].submit()">Save</A> 
		</TD>
	</TR>
<%		
			CMBAttribute attr;
			String attrName, attrDisplayName, attrValue;
			int attrType;
			
			// iterate over attributes of this item type
			for (int i = 0; i < attributes.length; i++) {		
				attr = attributes[i];
				attrName = attr.getName();
				attrType = attr.getType();
				attrValue = request.getParameter("attr." + attrType + "." + attrName);
				
				// if the attribute is present in the request initialize with its value, if not initialize with the default
				// if no default is available, leave the field empty
				if (attrValue == null) attrValue = (item == null) ? attr.getDefaultValue() : item.getAttrValues()[i];
                if (attrValue == null) attrValue = "";  // no value given, no default -> leave empty
				attrDisplayName = Helpers.prepareName(entity.getAttribute(attrName).getDisplayName());
  				if (attrName.equals(ProcessData.AUTO_LINK_ATTRIBUTE) && folderItem != null) {  // auto link attribute: make it read-only if a folder is present
					attrValue = folderItem.getAttrValue(ProcessData.AUTO_LINK_ATTRIBUTE);
%>
					<TR>
						<TD></TD>
						<TD><I><%=attrDisplayName%></I></TD>
						<TD><%=attrValue%>
						   <INPUT type="hidden" name="attr.<%=attrType%>.<%=attrName%>" value="<%=attrValue%>">
						</TD>
						<TD></TD>
					</TR>
<%				} // hide the built-in attributes WF_OnCreate and WF_OnDelete. Alternatively, a view could be used.
				else if (attrName.length() != 11 || !attrName.substring(0, 5).equals("WF_On")) {
				
					// if the attribute is not nullable, indicate that is mandatory by a preceding asterisk
					if (!attr.isNullable()) attrDisplayName = "<font color=\"red\">*</font>" + attrDisplayName;
%>
					<%-- show display name of the attribute and input field (INPUT or TEXTAREA depending on display size of value) for the value --%>
					<TR>
						<TD></TD>
						<TD><%=attrDisplayName%></TD>
						<TD><%=Helpers.defineInputField(attr.getSize(), "attr." + attrType + "." + attrName, attrValue)%></TD>
						<TD></TD>
					</TR>
<% 
				}
			} // for each attribute of the item type

			CMBEntity[] childEntities = entity.getSubEntities();
			CMBItem[] childItems;
			int numChildItems;
			String childAttrName;
			int childAttrType = CMBBaseConstant.CMB_DATATYPE_ITEM;
			
			// iterate over child attribute definitions
			for (int i = 0; i < childEntities.length; i++) {
				entity = childEntities[i];
				childAttrName = entity.getName();
				childItems = null;
				numChildItems = 0;
				
				// update an existing item: determine final position of child collection (where new child item should be appended)
				if (item != null) {
					childItems = item.getAttrItems(childAttrName);
					numChildItems = childItems.length;
				}
				attributes = entity.getAttributes();
				int limit = numChildItems;
				if (i == newChildIndex) limit++; // if a new child item is to be added (parameter 'addChild'): display an additional child item with empty attributes
				
				// iterate over members of a child item collection
				for (int k = 0; k < limit; k++) {
%>
					<TR>
						<TD></TD>
						<TD><B><%=Helpers.prepareName(entity.getDisplayName())%></B></TD>
						<TD></TD>
						<TD>
<%							if (k == 0) {  // display the 'AddChild' action on top of the item collection table %>
								<A href="updateAttributes.jsp?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&addChild=<%=i%>">Add Child</A>
<%							}              %>
						</TD>
					</TR>
<%						
					// iterate over attributes of a child item type
					for (int j = 0; j < attributes.length; j++) {
						attr = attributes[j];
				   		attrName = attr.getName();
				   		attrType = attr.getType();
			   			attrDisplayName = Helpers.prepareName(attr.getDisplayName());
			   			// precede mandatory attribute with a red asterisk
						if (!attr.isNullable()) attrDisplayName = "<font color=\"red\">*</font>" + attrDisplayName;
						attrValue = request.getParameter("attr." + + childAttrType + "." + childAttrName + ".intAttr." + k + "." + attrType + "." + attrName);
						
						// if child attribute value is in the parameter list, initialize with this value otherwise use default or blank intput field
						if (attrValue == null) attrValue = (childItems == null || k == numChildItems) ? attr.getDefaultValue() : childItems[k].getAttrValues()[j];
                        if (attrValue == null) attrValue = "";  // no value given, no default -> leave empty
%>
						<TR>
							<TD></TD>
							<TD>&nbsp;&nbsp;&nbsp;<%=attrDisplayName%></TD>
							<TD><%=Helpers.defineInputField(attr.getSize(), "attr." + childAttrType + "." + childAttrName +
							    ".intAttr." + k + "." + attrType + "." + attrName, attrValue)%></TD>
							<TD></TD>
						</TR>
<%
	    			} // iterate over attributes of child item type
	    		} // iterate over child item collection
  			} // iterate over child entities
%>		

	<%-- EDIT PARTS SECTION --%>

    <TR><TD colspan="4">&nbsp;</TD>
	<TR>
		<TD colspan="4" class="mainseparator">Edit parts</TD>
	</TR>
<%		int contentIndex = 0;
	    String styleClass;
	    boolean authorized;
%>			
			
		<TR>
			<TH>Part No</TH>
			<TH>Part type</TH>
			<TH>Mime type</TH>
			<TH>Action</TH>
		</TR>

<%		if (dataMgmt != null) { // parts available?

			int numberOfParts = dataMgmt.getContentCount();
			CMBObject content;
			
			// iterate over parts list
			for (int i = 0; i < numberOfParts; i++) {
				content = dataMgmt.getContent(i);

				// use alternate background for adjacent part rows to improve readability
				styleClass = ( i % 2 == 0 )? "even" : "odd" ;
				String encodedContentId = java.net.URLEncoder.encode(content.getId(), "UTF-8");
%>
				<TR valign="top" class="<%=styleClass%>">
					<TD><%=i%></TD>
					<TD><%=content.getPartType()%></TD>
					<TD><%=content.getMimeType()%></TD>
					<TD>
			  		  <%-- Open a new window to show the content. This allows viewing/editing multiple parts of an item concurrently. --%>
						<A href="viewContent.jsp?menu=no&WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>&contentId=<%=encodedContentId%>&contentIndex=<%=contentIndex%>&contentMimeType=<%=content.getMimeType()%>" target="_blank">View</A><BR>
<%
						// check authorization prior to submitting a deletion request
						authorized = dataMgmt.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_DELETE_CONTENT) == CMBPrivilege.CMB_PRIV_YES;
						if (authorized) {
%>
							<A href="javascript:confirmation('<%=encodedItemId%>', '<%=encodedContentId%>', '<%=contentIndex%>')">Delete</A>
<%						}  %>
					</TD>
				</TR>
<%
			}  // iterate over parts list
		} // dataMgmt != null
		
		// parts can only be added, if the item has already been created and if the appropriate privileges are in place
		if (itemId.length() > 0 && dataMgmt.getPrivilege().checkAuthorization(CMBPrivilege.CMB_PRIV_ADD_CONTENT) == CMBPrivilege.CMB_PRIV_YES) { 
%>
			<TR><TD colspan="4">&nbsp;</TD></TR>

			<TR class="itementry">
				<TD colspan="3"></TD>
				<TD>
					<A href="importPart.jsp?WF_AIID=<%=aiidString%>&folderPid=<%=encodedFolderPid%>&itemId=<%=encodedItemId%>">Add Part</A>
				</TD>
			</TR>
<%		}
%>

</TABLE>
</FORM>

</BODY>
</HTML>
