<%--
@copyright(disclaimer) 
Licensed Materials - Property of IBM
IBM DB2 Content Manager Enterprise Edition V8  (program number 5724-B19)
IBM DB2 Content Manager Express Edition V8 (program number 5724-F73)
IBM DB2 Content Manager for z/OS V8 (program number 5697-H60)
(c ) Copyright IBM Corp. 1994,  2005. All Rights Reserved.

US Government Users Restricted Rights                                  
Use, duplication or disclosure restricted by GSA ADP Schedule          
Contract with IBM Corp.     

DISCLAIMER OF WARRANTIES :
                                                                       
Permission is granted to copy and modify this Sample code, and to      
distribute modified versions provided that both the copyright        
notice, and this permission notice and warranty disclaimer  appear in all copies and modified  
versions. 

This software is provided "AS IS."  IBM and its Suppliers and Licensors expressly disclaim all
warranties, whether  EXPRESS OR IMPLIED,  INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE OR WARRANTY OF  NON-INFRINGEMENT.  IBM AND ITS SUPPLIERS AND
LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE THAT RESULT FROM USE OR
DISTRIBUTION OF THE SOFTWARE OR THE COMBINATION OF THE SOFTWARE WITH ANY OTHER CODE.
IN NO EVENT WILL IBM OR ITS SUPPLIERS  AND LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR
DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER
CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE
SOFTWARE, EVEN IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.          
                                                                 
@endCopyright
--%>

<%-- This JSP shows a content object either by running the viewer applet or by sending the binary data stream to the browser
	 so it can be displayed using an appropriate plugin (restricting the range of available actions to read access).
	 Note that this page does not use the header.jsp since it may redirect the request to the GetContentServlet which sends the
	 binary data stream to the browser replacing any HTML rendering this JSP might have done.
	 Clicking 'Edit' on a part shown in the showWorkItem page opens this JSP in a new window. This enables the user to view
	 different parts of an item or of multiple items at the same time.
--%>

<%
	String itemPid			= request.getParameter("itemId");
	String encItemId 	    = java.net.URLEncoder.encode(itemPid, "UTF8");
	String encodedContentId = java.net.URLEncoder.encode(request.getParameter("contentId"), "UTF8");
	String contentIndex     = request.getParameter("contentIndex");
	String contentMimeType  = request.getParameter("contentMimeType");

	// URL context
	String urlPrefix = "http://" + request.getServerName() + ":" + request.getServerPort() + request.getContextPath() + "/";

	// URL for contentId identifying the part that should be displayed in viewer 
	String getDocServlet = urlPrefix + "GetContentServlet?itemId=" + encItemId + "&contentId=" + encodedContentId;

 
	// list of Mime Types supported by the applet viewer (see IDMAdminDefaults.properties)
	String[] supportedMimeTypes = { "text/plain", "image/gif", "image/jpg", "image/jpeg", "image/tiff", "application/vnd.ibm.modcap",
                                    "image/bmp",  "image/pcx", "image/dcx" };

	int count = supportedMimeTypes.length;
	while (--count >= 0) { if (contentMimeType.equals(supportedMimeTypes[count])) break; }

	if (count >= 0) { // the mime type is supported by the viewer applet: have the view applet display the part
			
		String getAnnoServlet, addAnnoServlet, delAnnoServlet;

		// retrieve the item type definition for this item to determine if the part type ICMANNOTATION is supported
		// if not: do not provide URLs vor annotation services (-> menu entries in applet will be disabled in this case)
	    CMBDataManagement dataBean = Helpers.setupDataBean(request, itemPid, false);
    	CMBItem item = dataBean.getDataObject();
		CMBConnection connection = (CMBConnection) session.getAttribute("connection");
		CMBSchemaManagement schemaBean = connection.getSchemaManagement();
    	CMBEntity entity = schemaBean.getEntity(item.getEntityName());	
    	String[] partTypes = entity.getPartTypes();
    	count = partTypes.length;
		while(--count >= 0) { if (partTypes[count].equals("ICMANNOTATION")) break; }
		if (count < 0) {  // ICMANNOTATION is not supported: leave annotation service URLs empty
			getAnnoServlet = "";
			addAnnoServlet = "";
			delAnnoServlet = "";
		}
		else {
			String urlPostfix = "AnnotationServlet?itemId=" + encItemId + "&contentIndex=" + contentIndex;

			// URLs to be requested by the Annotation Service callbacks
			getAnnoServlet = urlPrefix + "Get"+ urlPostfix;
			addAnnoServlet = urlPrefix + "Add" + urlPostfix;
			delAnnoServlet = urlPrefix + "Delete" + urlPostfix;
		}

		// customize the title text
		request.setAttribute("title", "View Content");
%>

		<%@include file="header.jsp"%>
		<%@page errorPage="/error.jsp"%>

		<%-- embed the viewer applet --%>
			
		<jsp:plugin type="applet" code="appletViewer/TViewerApplet.class"
					codebase="appletViewer/" width="100%" height="90%" name="TViewerApplet"
					archive="appletViewer.jar, cmbview81.jar" align="bottom">
		<jsp:params>
			<jsp:param name="DOC_SERVLET" value="<%=getDocServlet%>" />
			<jsp:param name="ANNO_SERVLET" value="<%=getAnnoServlet%>" />
			<jsp:param name="ADD_ANNO_SERVLET" value="<%=addAnnoServlet%>" />
			<jsp:param name="DEL_ANNO_SERVLET" value="<%=delAnnoServlet%>" />
			</jsp:params>
			<jsp:fallback>Plugin is not supported.</jsp:fallback>
		</jsp:plugin>
<% }
    else { // the mime type is not supported by the viewer applet: send the content to the browser using the GetContentServlet
%>
		<HTML>
			<HEAD>
				<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
				<META http-equiv="Expires" content="-1">
				<LINK rel="stylesheet" href="css/style.css">
				<TITLE>CM/BPC Quick Start Client - View Content</TITLE>
			</HEAD>
			<FRAMESET rows="81,*" border="0" frameborder="0" framespacing="0">
	    		<FRAME src="header.jsp?menu=no" name="Header" marginwidth="0" marginheight="0" scrolling="no" noresize>
	   			<FRAME src="<%=getDocServlet%>" name="Viewer" marginwidth="0" marginheight="0">
			</FRAMESET>
			<BODY>
<%	}
%>
</BODY>
</HTML>
